!**************************************************************************
! 𑜓x(Cramer̃f[^Zbgɏ)̃V~[Vo͂͂       
! GrADSp̃f[^t@C쐬c[                            
! (C)2006 Hisashi SATO (FRCGC/JAMSTEC)                                     
!                                                                          
! -- Input files                                                           
!                                                                          
! -- Output files                                                          
! data.grb                                                                 
! data.ctl                                                                 
!                                                                          
!**************************************************************************

PROGRAM pre_grads
implicit none

!***** Define parameters *****
   integer,parameter::Simulation_year = 1   !simulation year (yr)
   integer,parameter::Interval        = 1     !data output interval (yr)
   
   integer,parameter::Num_point       = 1631
   integer,parameter::Num_lon         =   96
   integer,parameter::Num_lat         =   72
   integer,parameter::Num_data        =   21
   real   ,parameter::Undef           =-10.0
   
   logical,parameter::Grads_out       = .true. !Swith to output GraDs input files
   
!***** Define local variables *****
   real   ,dimension(Num_point,2)    :: Landpix   !Land pixel
   integer,dimension(Num_lon,Num_lat):: Grid_num  !Grid number (ocean when zero)
   
   !(point,month,data_no)
   real,dimension(Num_data)                                                 ::data_read
   real,dimension(Num_point, 12*int(Simulation_year/Interval), Num_data)    ::data_input
   real,dimension(12*int(Simulation_year/Interval)*Num_lat*Num_lon*Num_data)::data_write
   
   real,dimension(Simulation_year/Interval, 26)::annual_change
   
   real,dimension(Simulation_year/Interval):: &
   sum_all, sum_tropical, sum_temperate, sum_boreal, sum_arid
   
   real,dimension(10)::a
   integer point, i, j, t, mo, year, time, count, lon, lat
   integer biome, n, rec_data, rec_data1, rec_data2, rec_data3
   real    x, y, z, gpp, npp
   
!***** Prepare land-ocean mask *****
write(*,*) 'Preparing land-ocean mask ...'
   
   open (1, file='landpix.dat', status='OLD')
   read (1, *) ( Landpix(point,:), point=1, Num_point )
   close(1)
   
   Grid_num(:,:) = 0 ! zero means ocean
   Do point=1, Num_point
      i = int( (Landpix(point,1)+180)/3.75 + 0.5 ) !Longitude number
      j = int( (Landpix(point,2)+ 90)/2.50 + 0.5 ) !Latitude number
      Grid_num(i,j) = point
   End do
   
!***** Read simulation data ************
write(*,*) 'Reading simulation output...'
   
   Open (1, file='output.txt', status='OLD')
   
!   Do point = 1, Num_point
!   Do year  = 1, Simulation_year
!   Do mo    = 1, 12
!      read(1,*) data_read(:)
!      if ( mod(year,Interval)==0 ) data_input(point, int(year/Interval)*12+mo, :) = data_read(:)
!   End do
!   End do
!   End do
   
   Do point = 1, Num_point
   write(*,*) 'point -> ',  point
   Do time = 1, int(Simulation_year/Interval) * 12
      read(1,*) data_read(:)
      data_input(point, time, :) = data_read(:)
   End do
   End do
   
   Close (1)

!***** Data processing ************
write(*,*) 'Data processing...'
  !Grads\̒̂߂́Af[^vZX
   Do point = 1, Num_point
   Do time = 1, int(Simulation_year/Interval) * 12
      data_input(point, time, 14) = max(0.01, data_input(point, time, 14) )
      data_input(point, time, 15) = max(0.01, data_input(point, time, 15) )
   End do
   End do

!***** WRITE meta-data for GrADS analysis ***********
IF (Grads_out) then
write(*,*) 'Making meta-data file for GrADS analysis ... '
   
   data_write(:) = Undef !default value
   
   count = 0
   Do time = 1, int(Simulation_year/Interval) * 12
   Do n    = 1, Num_data
   Do lat  = 1, Num_lat
   Do lon  = 1, Num_lon
      
      count = count + 1
      point = Grid_num(lon,lat)
      if (point .ne. 0) data_write(count)=data_input(point,time,n)
      
   End do
   End do
   End do
   End do
   
!xɑSăt@Co͂ꍇ
   rec_data = int(Simulation_year/Interval)*12 * Num_lat*Num_lon * Num_data
   Open (1, file='data.grb', form='UNFORMATTED', access='DIRECT', recl=4*rec_data)
      write (1, rec=1) (data_write(i), i=1, rec_data)   
   Close (1)

!t@C𕪊ďo͂ꍇ
!   rec_data1 = 139*12 * Num_lat*Num_lon * Num_data
!   rec_data2 = 100*12 * Num_lat*Num_lon * Num_data
!   rec_data3 = 100*12 * Num_lat*Num_lon * Num_data
!   
!   !1861-2000
!   write(*,*) 'Years 1861-2000'
!   Open (1, file='data1.grb', form='UNFORMATTED', access='DIRECT', recl=4*rec_data1)
!      write (1, rec=1) (data_write(i), i=1, rec_data1)
!   Close (1)
!   
!   !2001-2100
!   write(*,*) 'Years 2001-2100'
!   Open (1, file='data2.grb', form='UNFORMATTED', access='DIRECT', recl=4*rec_data2)
!      write (1, rec=1) (data_write(i), i=1+rec_data1, rec_data1+rec_data2)
!   Close (1)
!   
!   !2101-2200
!   write(*,*) 'Years 2101-2200'
!   Open (1, file='data3.grb', form='UNFORMATTED', access='DIRECT', recl=4*rec_data3)
!      write (1, rec=1) (data_write(i), i=1+rec_data1+rec_data2, rec_data1+rec_data2+rec_data3)
!   Close (1)

END IF


!***** WRITE data description file for GrADS analysis *****
IF (Grads_out) then
write(*,*) 'Writing control-data file for GrADS analysis ...'
   
   Open (1, file='data.ctl')
   
   !-------- File Properties --------
   write(1,'(a)'         ) '********* basic ***********'
   write(1,'(a)'         ) 'dset ^data1.grb'
   write(1,'(a)'         ) 'title "Simulation result of SEIB-DGVM"'
   write(1, '(a6,f10.5)' ) 'undef ', Undef
   write(1,'(a)'         ) ''
   
   !-------- Data size --------
   write(1,'(a)') '********* dimension ***********'
   
   x = real(0.5 * (360.0/Num_lon) -180.0) !start longitude
   write(1,'(a,i5,a,2f10.5)') 'xdef ', Num_lon, ' linear ', x, 3.75
   
   x = real(0.5 * (180.0/Num_lat) -90.0)  !start latitude
   write(1,'(a,i5,a,2f10.5)'  ) 'ydef ', Num_lat, ' linear ', x, 2.5
   
   write(1,'(a)') 'zdef 1 linear 1 1'
   
   write(1,'(a)') 'tdef  1668 linear 0Z1jan1860  1mo'
   write(1,'(a)') '* tdef  1200 linear 0Z1jan2000  1mo'
   write(1,'(a)') '* tdef  1200 linear 0Z1jan2100  1mo'
   write(1,'(a)') ''
   
   !-------- Definition of variables --------
   write(1,'(a)') '********* variables ***********'
   write(1,'(a)') 'vars 21'
   write(1,'(a)') 'biome    0  99  BIOME                     [0-17]'               !  1
   write(1,'(a)') 'c_w      0  99  Carbon in Woody biomass   [kg C / m2]'          !  2
   write(1,'(a)') 'c_g      0  99  Carbon in Grass biomass   [kg C / m2]'          !  3
   write(1,'(a)') 'som1     0  99  Carbon in litter          [kg C / m2]'          !  4
   write(1,'(a)') 'som2     0  99  Carbon in som_int         [kg C / m2]'          !  5
   write(1,'(a)') 'som3     0  99  Carbon in som_slow        [kg C / m2]'          !  6
   write(1,'(a)') 'pl_w1    0  99  Water in upper soil layer [mm]'                 !  7
   write(1,'(a)') 'pl_w2    0  99  Water in lower soil layer [mm]'                 !  8
   write(1,'(a)') 'pl_sn    0  99  Water in snow             [mm]'                 !  9
   write(1,'(a)') 'gpp      0  99  GPP                       [kg C / m2 / month]'  ! 10
   write(1,'(a)') 'npp      0  99  NPP                       [kg C / m2 / month]'  ! 11
   write(1,'(a)') 'nep      0  99  NEP                       [kg C / m2 / month]'  ! 12
   write(1,'(a)') 'wm       0  99  mean woody mass           [kg C / tree]'        ! 13
   write(1,'(a)') 'lai_w    0  99  LAI of woody PFTs         [m2 / m2]'            ! 14
   write(1,'(a)') 'lai_g    0  99  LAI of grass PFTs         [m2 / m2]'            ! 15
   write(1,'(a)') 'w_ro     0  99  water1: runoff            [mm / month]'         ! 16
   write(1,'(a)') 'w_ic     0  99  water2: interception      [mm / month]'         ! 17
   write(1,'(a)') 'w_ev     0  99  water3: evaporation       [mm / month]'         ! 18
   write(1,'(a)') 'w_tr     0  99  water4: transpiration     [mm / month]'         ! 19
   write(1,'(a)') 'td       0  99  tree density              [N / ha]'             ! 20
   write(1,'(a)') 'cd       0  99  monthly stomatal conductance [mol H2O m-2 s-1]' ! 21
   write(1,'(a)') 'endvars'
   
   Close (1)
END IF

!***** Global analysis for annual change *****
write(*,*) 'Analysing annual change (Phase 1) ...'

annual_change(:,:) = 0.0

y                  = 0.0
z                  = 0.0
sum_all      (:)   = 0.0
sum_tropical (:)   = 0.0
sum_temperate(:)   = 0.0
sum_boreal   (:)   = 0.0
sum_arid     (:)   = 0.0

Do lon = 1,  Num_lon !(maximum length: 1~96)
Do lat = 1,  Num_lat !(maximum length: 1~72)
   
   !point: V~[Vn_ԍiCm̏ꍇ0j
   point = Grid_num(lon,lat)
   
   !x: Sς̂߂̌W
   !y: Wx̑Sv
   x = 90 - ( (lat-0.5) / Num_lat ) * 180    !ox
   x = cos( (3.141592/2.0) * abs(x) / 90.0 ) !cos(ox)
   y = y + x                                 !cos(ox)̑Sv
   
If ( point .ne. 0 ) then
    !z: Wx̗ʍv
     z = z + x
     
     Do year=1, Simulation_year/Interval
     Do mo=1, 12
       !Get record information
        time = (year-1)*12 + mo                !Time record number
        biome    = int( data_input(point,time,1) ) !Biome number
        
       !For all biome
        annual_change(year,1)= annual_change(year, 1) + data_input(point,time,2)*x  &
                                                      + data_input(point,time,3)*x  !Biomass
        annual_change(year,2)= annual_change(year, 2) + data_input(point,time,5)*x  &
                                                      + data_input(point,time,6)*x  !SOM
        annual_change(year,3)= annual_change(year, 3) + data_input(point,time,4)*x  !Litter
        
        annual_change(year,4)= annual_change(year, 4) + data_input(point,time,10)*x !GPP
        annual_change(year,5)= annual_change(year, 5) + data_input(point,time,11)*x !NPP
        annual_change(year,6)= annual_change(year, 6) + data_input(point,time,12)*x !NEP
        
        annual_change(year,7)= annual_change(year, 7) + data_input(point,time,16)*x !runoff        
        annual_change(year,8)= annual_change(year, 8) + data_input(point,time,17)*x !interception  
        annual_change(year,9)= annual_change(year, 9) + data_input(point,time,18)*x !evaporation   
        annual_change(year,10)=annual_change(year,10) + data_input(point,time,19)*x !transpiration 
        
        annual_change(year,11)=annual_change(year,11) + data_input(point,time,14)*x !LAI of tree
        annual_change(year,12)=annual_change(year,12) + data_input(point,time,15)*x !LAI of grass
        
       !Tropical rain forest
       if (biome==3 .or. biome==4) then
          sum_tropical(year) = sum_tropical(year) + x/12
          annual_change(year,15)= annual_change(year,15) + data_input(point,time,10)*x !GPP
          annual_change(year,16)= annual_change(year,16) + data_input(point,time,11)*x !NPP
          annual_change(year,17)= annual_change(year,17) + data_input(point,time,12)*x !NEP
       endif
       
       !Temperate deciduous forest
       if (biome==8) then
          sum_temperate(year) = sum_temperate(year) + x/12
          annual_change(year,18)= annual_change(year,18) + data_input(point,time,10)*x !GPP
          annual_change(year,19)= annual_change(year,19) + data_input(point,time,11)*x !NPP
          annual_change(year,20)= annual_change(year,20) + data_input(point,time,12)*x !NEP
       endif
       
       !Boreal forest
       if (biome==9 .or. biome==10) then
          sum_boreal(year) = sum_boreal(year) + x/12
          annual_change(year,21)= annual_change(year,21) + data_input(point,time,10)*x !GPP
          annual_change(year,22)= annual_change(year,22) + data_input(point,time,11)*x !NPP
          annual_change(year,23)= annual_change(year,23) + data_input(point,time,12)*x !NEP
       endif
       
       !Grassland, Savannas, Steppe
       if (biome==11 .or. biome==12 .or. biome==13 .or. biome==14 .or. biome==16) then
          sum_arid(year) = sum_arid(year) + x/12
          annual_change(year,24)= annual_change(year,24) + data_input(point,time,10)*x !GPP
          annual_change(year,25)= annual_change(year,25) + data_input(point,time,11)*x !NPP
          annual_change(year,26)= annual_change(year,26) + data_input(point,time,12)*x !NEP
       endif
       
     End do !month
     End do !year
     
End if 
End do !lat
End do !lon

y = max(1, y)
z = max(1, z)
sum_tropical (:) = max(1, sum_tropical (:))
sum_temperate(:) = max(1, sum_temperate(:))
sum_boreal   (:) = max(1, sum_boreal   (:))
sum_arid     (:) = max(1, sum_arid     (:))

!unit adjustment
!Surface area of the earth is 0.5093 P m2, where P is 1E+15
write(*,*) 'Analysing annual change (Phase 2) ...'
Do year=1, Simulation_year/Interval
   !Carbon stock (PgC earth-1)
   annual_change(year, 1) = annual_change(year, 1) * 0.5093 * 1000.0 / 12.0 / y !Biomass
   annual_change(year, 2) = annual_change(year, 2) * 0.5093 * 1000.0 / 12.0 / y !SOM
   annual_change(year, 3) = annual_change(year, 3) * 0.5093 * 1000.0 / 12.0 / y !Litter
   
   !Carbon fluxes (PgC earth-1 year-1)
   annual_change(year, 4) = annual_change(year, 4) * 0.5093 * 1000.0        / y !GPP
   annual_change(year, 5) = annual_change(year, 5) * 0.5093 * 1000.0        / y !NPP
   annual_change(year, 6) = annual_change(year, 6) * 0.5093 * 1000.0        / y !NEP
   
   !Carbon fluxes (10^12 m3 earth-1 year-1)
   annual_change(year, 7) = annual_change(year, 7) * 0.5093                 / y !Runoff
   annual_change(year, 8) = annual_change(year, 8) * 0.5093                 / y !Interception
   annual_change(year, 9) = annual_change(year, 9) * 0.5093                 / y !Evaporation
   annual_change(year,10) = annual_change(year,10) * 0.5093                 / y !Transpiration
   
   !LAI (m2 m-2, ݂̂̕)
   annual_change(year,11) = annual_change(year,11)                   / 12.0 / z !LAI of tree
   annual_change(year,12) = annual_change(year,12)                   / 12.0 / z !LAI of grass
   
   !Carbon fluxes for each biome (KgC m-2 year-1)
   annual_change(year,15) = annual_change(year,15) / sum_tropical (year) !GPP (tropical forest)
   annual_change(year,16) = annual_change(year,16) / sum_tropical (year) !NPP (tropical forest)
   annual_change(year,17) = annual_change(year,17) / sum_tropical (year) !NEP (tropical forest)
   
   annual_change(year,18) = annual_change(year,18) / sum_temperate(year) !GPP (temperate forest)
   annual_change(year,19) = annual_change(year,19) / sum_temperate(year) !NPP (temperate forest)
   annual_change(year,20) = annual_change(year,20) / sum_temperate(year) !NEP (temperate forest)
   
   annual_change(year,21) = annual_change(year,21) / sum_boreal   (year) !GPP (boreal forest)
   annual_change(year,22) = annual_change(year,22) / sum_boreal   (year) !NEP (boreal forest)
   annual_change(year,23) = annual_change(year,23) / sum_boreal   (year) !NEP (boreal forest)
   
   annual_change(year,24) = annual_change(year,24) / sum_arid     (year) !GPP (arid biome)
   annual_change(year,25) = annual_change(year,25) / sum_arid     (year) !NPP (arid biome)
   annual_change(year,26) = annual_change(year,26) / sum_arid     (year) !NEP (arid biome)
End do

write(*,*) 'Analysing annual change (Phase 3) ...'

Open (1, file='annual_change1.txt')
Do year=1, Simulation_year/Interval
   write(1,*) annual_change(year, 1:12)
End do
Close(1)

Open (1, file='annual_change2.txt')
Do year=1, Simulation_year/Interval
   write(1,*) annual_change(year, 15:26)
End do
Close(1)




!***** Data Overview *****
a(:) = 0.0
y    = 0.0

Do lon = 1,  Num_lon !(maximum length: 1~96)
Do lat = 1,  Num_lat !(maximum length: 1~72)

!x: Sς̂߂̌W
x = 90 - ( (lat-0.5) / Num_lat ) * 180    !ox
x = cos( (3.141592/2.0) * abs(x) / 90.0 ) !cos(ox)
y = y + x                                 !cos(ox)̑Sv

point = Grid_num(lon,lat)
If ( point .ne. 0 ) then
     
     !V~[VŏINx̑SĂ̌ɂ
     Do time = int(Simulation_year/interval)*12-11, int(Simulation_year/interval)*12
       
     !V~[VNx̑SĂ̌ɂ
     !Do time = 1, 12
       
       a( 1) = a( 1) + data_input(point,time,2)*x/12 + data_input(point,time,3)*x/12 !Biomass
       a( 2) = a( 2) + data_input(point,time,5)*x/12 + data_input(point,time,6)*x/12 !SOM
       a( 3) = a( 3) + data_input(point,time,4)*x/12                                 !Litter
       
       a( 4) = a( 4) + data_input(point,time,10)*x !GPP
       a( 5) = a( 5) + data_input(point,time,11)*x !NPP
       a( 6) = a( 6) + data_input(point,time,12)*x !NEP
       
       a( 7) = a( 7) + data_input(point,time,16)*x !runoff        
       a( 8) = a( 8) + data_input(point,time,17)*x !interception  
       a( 9) = a( 9) + data_input(point,time,18)*x !evaporation   
       a(10) = a(10) + data_input(point,time,19)*x !transpiration 
       
     End do
     
Endif

End do
End do
a(:) = a(:) / y

!Surface area of the earth is 0.5093 P m2, where P is 1E+15
write(*,*) 
write(*,*) '-------- Data Overview (@the last simulation year) -------'
write(*,*) 
write(*,*) 'Global carbon pool (Pg C): '
write(*,*) '   Biomass -> ', a(1) * 0.5093 * 1000.0
write(*,*) '   S.O.M.  -> ', a(2) * 0.5093 * 1000.0
write(*,*) '   Litter  -> ', a(3) * 0.5093 * 1000.0
write(*,*) 
write(*,*) 'Global carbon flux (Pg C / Year): '
write(*,*) '    GPP    -> ', a(4) * 0.5093 * 1000.0
write(*,*) '    NPP    -> ', a(5) * 0.5093 * 1000.0
write(*,*) '    NEP    -> ', a(6) * 0.5093 * 1000.0
write(*,*) 
write(*,*) 'Global water flux (10^12 m3 yr-1): '
write(*,*) '    RO     -> ',        a( 7) * 0.5093
write(*,*) '    IC     -> ',        a( 8) * 0.5093
write(*,*) '    EV     -> ',        a( 9) * 0.5093
write(*,*) '    TR     -> ',        a(10) * 0.5093
write(*,*) '    Total  -> ', sum(a(7:10)) * 0.5093




END program pre_grads

!*************** Input data number ***************
! 1: Biome no (classfication)
! 2: Carbon in Woody biomass [kg C / m2]
! 3: Carbon in Grass biomass [kg C / m2]
! 4: Carbon in litter        [kg C / m2]
! 5: Carbon in som_int       [kg C / m2]
! 6: Carbon in som_slow      [kg C / m2]
! 7: Water in soil layer 1   [mm]
! 8: Water in soil layer 2   [mm]
! 9: Water in snow           [mm]
!10: GPP                     [kg C / m2 / month]
!11: NPP                     [kg C / m2 / month]
!12: NEP                     [kg C / m2 / month]
!13: mean_woody_mass         [kg C / tree]
!14: LAI of woody PFTs       [m2/m2]
!15: LAI of grass PFTs       [m2/m2]
!16: runoff                  [mm/month]
!17: interception            [mm/month]
!18: evaporation             [mm/month]
!19: transpiration           [mm/month]
!20: tree_density            [N / ha]
!21: monthly stomatal conductance [mol H2O m-2 s-1]

!22: lai over lapping status
!23: ro  over lapping status

!********************************************************************
!Biome code
! 0: - water -
! 1: Polar desert
! 2: Arctic/Alpine-tundra
! 3: tropical rain forest (wet in any month)
! 4: tropical rain forest (seasonaly cycle of water situation)
! 5: tropical deciduous forest
! 6: temperate conifer forest
! 7: temperate broad-leaved evergreen forest
! 8: temperate deciduous forest
! 9: boreal evergreen forest / woodland
!10: boreal deciduous forest / woodland
!11: short grass land
!12: tall grass land
!13: moist savannas
!14: dry savannas
!15: xeric woodland / scrub
!16: Arid shrubland / steppe
!17: Desert
!********************************************************************
